function [xout] = Andrzejak_PRE_90_062906_RandomizePhases(x)
% This source code forms part of the resources provided at http://ntsa.upf.edu/downloads .
% It belongs to the library used for the computations underlying our manuscript.
% Andrzejak RG, Mormann F, Kreuz T.  2014.  Detecting determinism from point processes. Phys. Rev. E. 90, 062906
% In order to understand how the source code works, you should at first
% read the manuscript. A preprint can be found following the link above.
% If you use the source codes, please make sure that you give a reference to
% the manuscript. The correct way to cite this paper is shown above.
% No page numbers should be given in the reference.
%
% +++ What this particular script does:
%
% Generates a phase-randomized surrogate of the signal x

N = length(x);

y = fft(x,N);
for k = 2:N/2
    iphase=1i*rand*2*pi;    
    y(k) = abs(y(k))*exp(iphase);
    y(N-k+2) = abs(y(k))*exp(-iphase);        
end
xout = real(ifft(y,N));




